"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

exports.default = function (path, options) {
    var node = path.node;


    var propsIdentifier = node.openingElement.attributes.reduce(toPropsIdentifier, t.identifier("props"));

    var params = [propsIdentifier];
    var expression = (0, _commonLib.combineElements)((0, _commonLib.getChildren)(node), options);

    if (t.isJSXText(expression)) {
        expression = t.stringLiteral(expression.value);
    } else if (t.isJSXExpressionContainer(expression)) {
        expression = expression.expression;
    }

    var arrayFunction = t.arrowFunctionExpression(params, expression);

    (0, _commonLib.appendExpressions)([arrayFunction], path, options);
};

var _commonLib = require("./common-lib.js");

var t = require("babel-types");

function toPropsIdentifier(initial, attribute) {
    if (attribute.name.name == "props" && t.isStringLiteral(attribute.value)) {
        return t.identifier(attribute.value.value);
    }

    return initial;
}